# -*- mode: bash -*-

# update window size after every command
shopt -s checkwinsize

# prepend cd to directory names automatically
shopt -s autocd

shopt -s dirspell
shopt -s cdspell

# READLINE

# perform file completion in a case
# insensitive fashion
bind "set completion-ignore-case on"
# treat hyphens and underscores as equivalent
bind "set completion-map-case on"
# display matches for ambiguous patterns
# at first tab press
bind "set show-all-if-ambiguous on"
# immediately add a trailing slash when
# autocompleting symlinks to directories
bind "set mark-symlinked-directories on"

# vi mode configurations
bind "set vi-ins-mode-string \1\e[6 q\2\1ins\2"
bind "set vi-cmd-mode-string \1\e[2 q\2\1cmd\2"
bind "set show-mode-in-prompt on"

# ➜
